const { DataTypes } = require("sequelize");

module.exports = (sequelize) => {
	const PtkpStatus = sequelize.define(
		"ptkpstatus",
		{
			id: {
				type: DataTypes.INTEGER,
				autoIncrement: true,
				primaryKey: true,
			},
			creation: { type: DataTypes.DATE, allowNull: false },
			modified: { type: DataTypes.DATE, allowNull: false },
			modified_by: { type: DataTypes.INTEGER, allowNull: false },
			owner: { type: DataTypes.INTEGER, allowNull: false },
			enabled: { type: DataTypes.BOOLEAN, allowNull: false },

			// main
			name: { type: DataTypes.STRING(50), allowNull: false },
			display_name: { type: DataTypes.STRING(50), allowNull: false },

			// fk
			company_id: {
				type: DataTypes.INTEGER,
				allowNull: true,
			},
		},
		{
			tableName: "ptkpstatuses",
			freezeTableName: true,
		}
	);

	/**
	 * Associates the PtkpStatus model with other models.
	 * @param {object} models - The models to associate with.
	 */
	PtkpStatus.associate = (models) => {
		PtkpStatus.belongsTo(models.Company, { foreignKey: "company_id", as: "company" });

		PtkpStatus.hasMany(models.Employee, { foreignKey: "ptkpstatus_id", as: "employees" });

		PtkpStatus.belongsTo(models.User, { foreignKey: "modified_by", as: "modifier" });
	};

	return PtkpStatus;
};
